#include "montecarlodistribution.ih"

void MonteCarloDistribution::predict(rIDistribution const &movementModel)
{
  vector<Particle> newParticles;
  for (unsigned i = 0; i < d_nParticles; i++)
  {
    Particle oldP;
    rouletteSelect(oldP);
    Vector3D dcoords;
    movementModel->getX(dcoords);
    oldP.coords += dcoords;
    oldP.p *= movementModel->getP(dcoords);
    newParticles.push_back(oldP);
  }
  d_particles = newParticles;
}
